<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qtcreator-dev-wizards.qdoc -->
  <title>Creating Wizards in Code | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >Creating Wizards in Code</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#introduction">Introduction</a></li>
<li class="level2"><a href="#relevant-classes">Relevant Classes</a></li>
<li class="level2"><a href="#setters-and-getters-of-iwizardfactory">Setters and Getters of IWizardFactory</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Creating Wizards in Code</h1>
<span class="subtitle"></span>
<!-- $$$qtcreator-dev-wizards.html-description -->
<div class="descr"> <a name="details"></a>
<a name="introduction"></a>
<h2 id="introduction">Introduction</h2>
<p>If the functionality provided by template-based <a href="http://doc.qt.io/qtcreator/creator-project-wizards.html">custom wizards</a> is not sufficient for your case, you can write wizards in code.</p>
<p>A wizard in Qt Creator is an instance of a class implementing the Core::IWizardFactory interface that has a creator function registered with IWizardFactory::registerFactoryCreator.</p>
<p>Implementing wizards requires:</p>
<ul>
<li>Writing a factory class that derives from Core::IWizardFactory. This is a very generic interface that does not make any assumption about what the wizard does and what its UI looks like.</li>
<li>Providing a set of parameters that determine how the wizard shows up in the list of wizards in the <b>New File or Project</b> dialog.<p>When deriving from Core::IWizardFactory, the constructor has to call the following setters provided by the base class:</p>
<ul>
<li><code>setId</code></li>
<li><code>setWizardKind</code></li>
<li><code>setIcon</code></li>
<li><code>setDescription</code></li>
<li><code>setDisplayName</code></li>
<li><code>setCategory</code></li>
<li><code>setDisplayCategory</code></li>
<li><code>setDescriptionImage</code></li>
<li><code>setRequiredFeatures</code></li>
<li><code>setFlags</code></li>
</ul>
</li>
<li>Implementing the wizard UI<p>Typically, this will be a class derived from Utils::Wizard. Utils::Wizard extends <a href="http://doc.qt.io/qt-5/qwizard.html">QWizard</a> with the functionality to show a progress bar on the left.</p>
</li>
<li>Implementing the wizard functionality<p>It is recommended to use Core::GeneratedFile to represent files that need to be written to disk. They allow to delay writing the actual data to disk till the wizard is done.</p>
</li>
</ul>
<a name="relevant-classes"></a>
<h3 id="relevant-classes">Relevant Classes</h3>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Class</th><th >Description</th></tr></thead>
<tr valign="top" class="odd"><td >Core::IWizardFactory</td><td >Qt Creator wizard interface, implementations of which are registered with ExtensionSystem::PluginManager.</td></tr>
<tr valign="top" class="even"><td >Core::GeneratedFile</td><td >A file containing name, contents, and some attributes.</td></tr>
<tr valign="top" class="odd"><td >Utils::FileWizardPage</td><td >Introductory wizard page asking for file name and path.</td></tr>
<tr valign="top" class="even"><td >Utils::ProjectIntroPage</td><td >Introductory wizard page asking for project name and path.</td></tr>
</table></div>
<a name="setters-and-getters-of-iwizardfactory"></a>
<h3 id="setters-and-getters-of-iwizardfactory">Setters and Getters of IWizardFactory</h3>
<p>The setters and getters listed below determine how the wizard shows up in the list of wizards in the <b>New File or Project</b> dialog.</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Type</th><th >Parameter Name</th><th >Description</th></tr></thead>
<tr valign="top" class="odd"><td >Core::IWizardFactory::WizardKind</td><td >kind</td><td >Enumeration value that indicates the type of the wizard (<code>project</code> or <code>file</code>).</td></tr>
<tr valign="top" class="even"><td ><a href="http://doc.qt.io/qt-5/qicon.html">QIcon</a></td><td >icon</td><td >Icon to show.</td></tr>
<tr valign="top" class="odd"><td ><a href="http://doc.qt.io/qt-5/qstring.html">QString</a></td><td >description</td><td >Descriptive text.</td></tr>
<tr valign="top" class="even"><td ><a href="http://doc.qt.io/qt-5/qstring.html">QString</a></td><td >displayName</td><td >Name to be shown in the list.</td></tr>
<tr valign="top" class="odd"><td ><a href="http://doc.qt.io/qt-5/qstring.html">QString</a></td><td >id</td><td >Unique identifier for the wizard. It also determines the order within a category.</td></tr>
<tr valign="top" class="even"><td ><a href="http://doc.qt.io/qt-5/qstring.html">QString</a></td><td >category</td><td >Identifier of the category under which the wizard is to be listed. It also determines the order of the categories.</td></tr>
<tr valign="top" class="odd"><td ><a href="http://doc.qt.io/qt-5/qstring.html">QString</a></td><td >displayCategory</td><td >Description of the category.</td></tr>
</table></div>
<p>All wizards that have the same category set will be grouped together in the <b>New File or Project</b> dialog.</p>
</div>
<!-- @@@qtcreator-dev-wizards.html -->
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
